targets = {'FPT': ['FPT'],
           'FVS': ['FVS'],
           'FOYD': ['FOYD'],
           'FOS': ['FOS'],
           'FPTP': ['FPTP'],
           'FVSP': ['FVSP'],
           'FOYDP': ['FOYDP'],
           'FYDR': ['FYDR'],
           'FUV': ['FUV_1', 'FUV_2', 'FUV_3'],
           'FDV': ['FDV_1', 'FDV_2', 'FDV_3'],
           'DWTT': ['DWTT1', 'DWTT2'],
           'DVC': ['DVC1', 'DVC2', 'DVC3'],
           'NB_': ['NB1', 'NB2'],
           'FPT05': ['FPT05'],
           'FPTP05': ['FPTP05']
           }

exclude = {
           'FPT': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FVS': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FOYD': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FOS': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FPTP': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FVSP': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FOYDP': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FYDR': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FUV': ['T_KCV', 'T_KCD', 'T_KCDV'],
           'FDV': ['T_KCU', 'T_KCD', 'T_KCDV'],
           'DWTT': ['T_KCU', 'T_KCV', 'T_KCDV'],
           'DVC': ['T_KCU', 'T_KCV', 'T_KCD'],
           'NB_': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FPT05': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV'],
           'FPTP05': ['T_KCU', 'T_KCV', 'T_KCD', 'T_KCDV']
          }

time_columns = ['ДЛИТ_ПЕЧЬ']

label_encoders = {
                  'ПР_ГП': ['HOT'],  # 5
                  'ТИПТЕХЭСПЦ': ['ДСП', 'ГМП'],  # 4
                  'ПР_УВС': ['УВС'],
                 }


error_codes = [
               'КОД_ОШИБКИ',  # 2
               'КОД_ЦЛК',  # 7
               'СТОППИР'  # 2
               ]


groups = [
          'H_СЛЯБ',  # 1
          'B_СЛЯБ',  # 1
          'L_СЛЯБ',
          'ВЕС_СЛ',  # 4
          'ВЕСФ_СЛ',  # 9
          'H_ЛИСТ',  # 5
          'B_ЛИСТ',  # 9
          'L_ЛИСТ',  # 3
          'КРАТ',
          'ПЕЧЬ_РЯД',  # 0
          'ДЛИТ_ПЕЧЬ',
          'ПЛ_Т_ПЕЧЬ',  # 0
          'ФК_Т_ПЕЧЬ',  # 6
          'СХЕМА_ПРОК',  # 6
          'ДУО_ПРОХ',  # 1
          'ДУО_ХОЛОСТ',  # 0
          'ГИДРОСБИВ',  # 3
          ['ДУО_ОБЖ_01','ДУО_ОБЖ_02','ДУО_ОБЖ_03','ДУО_ОБЖ_04','ДУО_ОБЖ_05','ДУО_ОБЖ_06','ДУО_ОБЖ_07','ДУО_ОБЖ_08','ДУО_ОБЖ_09','ДУО_ОБЖ_10','ДУО_ОБЖ_11','ДУО_ОБЖ_12','ДУО_ОБЖ_13','ДУО_ОБЖ_14','ДУО_ОБЖ_15',],  # 8
          ['ДУО_УСС_01','ДУО_УСС_02','ДУО_УСС_03','ДУО_УСС_04','ДУО_УСС_05','ДУО_УСС_06','ДУО_УСС_07','ДУО_УСС_08','ДУО_УСС_09','ДУО_УСС_10','ДУО_УСС_11','ДУО_УСС_12','ДУО_УСС_13','ДУО_УСС_14','ДУО_УСС_15',],  # 7
          ['ДУО_УСП_01','ДУО_УСП_02','ДУО_УСП_03','ДУО_УСП_04','ДУО_УСП_05','ДУО_УСП_06','ДУО_УСП_07','ДУО_УСП_08','ДУО_УСП_09','ДУО_УСП_10','ДУО_УСП_11','ДУО_УСП_12','ДУО_УСП_13','ДУО_УСП_14','ДУО_УСП_15',],  # 3
          ['ДУО_СКР_01','ДУО_СКР_02','ДУО_СКР_03','ДУО_СКР_04','ДУО_СКР_05','ДУО_СКР_06','ДУО_СКР_07','ДУО_СКР_08','ДУО_СКР_09','ДУО_СКР_10','ДУО_СКР_11','ДУО_СКР_12','ДУО_СКР_13','ДУО_СКР_14','ДУО_СКР_15'],
          'ДУО_Т_3_ПР',  # 7
          'ДУО_Т_ПОСЛ',  # 6
          'ПОДКАТ',  # 6
          ['КВР_ОБЖ_01','КВР_ОБЖ_02','КВР_ОБЖ_03','КВР_ОБЖ_04','КВР_ОБЖ_05','КВР_ОБЖ_06','КВР_ОБЖ_07','КВР_ОБЖ_08','КВР_ОБЖ_09','КВР_ОБЖ_10','КВР_ОБЖ_11','КВР_ОБЖ_12','КВР_ОБЖ_13','КВР_ОБЖ_14','КВР_ОБЖ_15',],  # 9
          ['КВР_УСС_01','КВР_УСС_02','КВР_УСС_03','КВР_УСС_04','КВР_УСС_05','КВР_УСС_06','КВР_УСС_07','КВР_УСС_08','КВР_УСС_09','КВР_УСС_10','КВР_УСС_11','КВР_УСС_12','КВР_УСС_13','КВР_УСС_14','КВР_УСС_15',],
          ['КВР_УСП_01','КВР_УСП_02','КВР_УСП_03','КВР_УСП_04','КВР_УСП_05','КВР_УСП_06','КВР_УСП_07','КВР_УСП_08','КВР_УСП_09','КВР_УСП_10','КВР_УСП_11','КВР_УСП_12','КВР_УСП_13','КВР_УСП_14','КВР_УСП_15',],  # 8
          ['КВР_СКР_01','КВР_СКР_02','КВР_СКР_03','КВР_СКР_04','КВР_СКР_05','КВР_СКР_06','КВР_СКР_07','КВР_СКР_08','КВР_СКР_09','КВР_СКР_10','КВР_СКР_11','КВР_СКР_12','КВР_СКР_13','КВР_СКР_14','КВР_СКР_15'],  # 9
          ['DELTA1_2','DELTA2_3','DELTA3_4','DELTA4_5','DELTA5_6','DELTA6_7','DELTA7_8','DELTA8_9','DELTA9_10','DELTA10_11','DELTA11_12','DELTA12_13','DELTA13_14','DELTA14_15'],  # 5
          'КВР_Т_ПЛАН',  # 2
          'КВР_Т_1_ПР',  # 7
          'S2_START',  # 3
          'КВР_Т_ПОСЛ',
          'КВР_ПРОХ',  # 1
          'ПЕЧЬ_ДУО',  # 4
          'ДУО_ВРЕМЯ',  # 4
          'ДУО_КВР',  # 4
          'КВР_ВРЕМЯ',  # 8
          'УГЛ_ЭКВ',  # 5
          'КХС',  # 2
          'C',  # 2
          'SI',  # 6
          'MN',  # 7
          'P',  # 9
          'S',  # 3
          'CR',  # 5
          'NI',  # 8
          'CU',
          'TI',
          'AL',  # 8
          'N2',
          'NB',
          'V',  # 0
          'B',  # 0
          'MO',  # 1
          'ISP_OB',
          'T_KCU',
          'T_KCV',
          'T_KCD',
          'T_KCDV'
]

predictors = [
          'ДЛИТ_ПЕЧЬ',
          'ПР_ГП',
          'ТИПТЕХЭСПЦ',
          'ПР_УВС',
          'КОД_ОШИБКИ',  # 2
          'КОД_ЦЛК',  # 7
          'СТОППИР',

          'H_СЛЯБ', 'B_СЛЯБ', 'L_СЛЯБ', 'ВЕС_СЛ', 'ВЕСФ_СЛ', 'H_ЛИСТ', 'B_ЛИСТ', 'L_ЛИСТ',  # 3
          'КРАТ', 'ПЕЧЬ_РЯД', 'ДЛИТ_ПЕЧЬ', 'ПЛ_Т_ПЕЧЬ', 'ФК_Т_ПЕЧЬ', 'СХЕМА_ПРОК', 'ДУО_ПРОХ',  # 1
          'ДУО_ХОЛОСТ', 'ГИДРОСБИВ',  # 3
          'Group_ДУО_ОБЖ_01', 'Group_ДУО_ОБЖ_02','Group_ДУО_ОБЖ_03','Group_ДУО_ОБЖ_04','Group_ДУО_ОБЖ_05',
          'Group_ДУО_ОБЖ_06','Group_ДУО_ОБЖ_07','Group_ДУО_ОБЖ_08','Group_ДУО_ОБЖ_09','Group_ДУО_ОБЖ_10',
          'Group_ДУО_ОБЖ_11','Group_ДУО_ОБЖ_12','Group_ДУО_ОБЖ_13','Group_ДУО_ОБЖ_14','Group_ДУО_ОБЖ_15',  # 8
          'Group_ДУО_УСС_01', 'Group_ДУО_УСС_02', 'Group_ДУО_УСС_03', 'Group_ДУО_УСС_04', 'Group_ДУО_УСС_05',
          'Group_ДУО_УСС_06', 'Group_ДУО_УСС_07', 'Group_ДУО_УСС_08', 'Group_ДУО_УСС_09', 'Group_ДУО_УСС_10',
          'Group_ДУО_УСС_11', 'Group_ДУО_УСС_12', 'Group_ДУО_УСС_13', 'Group_ДУО_УСС_14', 'Group_ДУО_УСС_15',
          'Group_ДУО_УСП_01', 'Group_ДУО_УСП_02', 'Group_ДУО_УСП_03', 'Group_ДУО_УСП_04', 'Group_ДУО_УСП_05',
          'Group_ДУО_УСП_06', 'Group_ДУО_УСП_07', 'Group_ДУО_УСП_08', 'Group_ДУО_УСП_09', 'Group_ДУО_УСП_10',
          'Group_ДУО_УСП_11', 'Group_ДУО_УСП_12', 'Group_ДУО_УСП_13', 'Group_ДУО_УСП_14', 'Group_ДУО_УСП_15',
          'Group_ДУО_СКР_01', 'Group_ДУО_СКР_02', 'Group_ДУО_СКР_03', 'Group_ДУО_СКР_04', 'Group_ДУО_СКР_05',
          'Group_ДУО_СКР_06', 'Group_ДУО_СКР_07', 'Group_ДУО_СКР_08', 'Group_ДУО_СКР_09', 'Group_ДУО_СКР_10',
          'Group_ДУО_СКР_11', 'Group_ДУО_СКР_12', 'Group_ДУО_СКР_13', 'Group_ДУО_СКР_14', 'Group_ДУО_СКР_15',
          'ДУО_Т_3_ПР',  # 7
          'ДУО_Т_ПОСЛ',  # 6
          'ПОДКАТ',  # 6
          'Group_КВР_ОБЖ_01', 'Group_КВР_ОБЖ_02', 'Group_КВР_ОБЖ_03', 'Group_КВР_ОБЖ_04', 'Group_КВР_ОБЖ_05',
          'Group_КВР_ОБЖ_06', 'Group_КВР_ОБЖ_07', 'Group_КВР_ОБЖ_08', 'Group_КВР_ОБЖ_09', 'Group_КВР_ОБЖ_10',
          'Group_КВР_ОБЖ_11', 'Group_КВР_ОБЖ_12', 'Group_КВР_ОБЖ_13', 'Group_КВР_ОБЖ_14', 'Group_КВР_ОБЖ_15',
          'Group_КВР_УСС_01', 'Group_КВР_УСС_02', 'Group_КВР_УСС_03', 'Group_КВР_УСС_04', 'Group_КВР_УСС_05',
          'Group_КВР_УСС_06', 'Group_КВР_УСС_07', 'Group_КВР_УСС_08', 'Group_КВР_УСС_09', 'Group_КВР_УСС_10',
          'Group_КВР_УСС_11', 'Group_КВР_УСС_12', 'Group_КВР_УСС_13', 'Group_КВР_УСС_14', 'Group_КВР_УСС_15',
          'Group_КВР_УСП_01', 'Group_КВР_УСП_02', 'Group_КВР_УСП_03', 'Group_КВР_УСП_04', 'Group_КВР_УСП_05',
          'Group_КВР_УСП_06', 'Group_КВР_УСП_07', 'Group_КВР_УСП_08', 'Group_КВР_УСП_09', 'Group_КВР_УСП_10',
          'Group_КВР_УСП_11', 'Group_КВР_УСП_12', 'Group_КВР_УСП_13', 'Group_КВР_УСП_14', 'Group_КВР_УСП_15',
          'Group_КВР_СКР_01', 'Group_КВР_СКР_02', 'Group_КВР_СКР_03', 'Group_КВР_СКР_04', 'Group_КВР_СКР_05',
          'Group_КВР_СКР_06', 'Group_КВР_СКР_07', 'Group_КВР_СКР_08', 'Group_КВР_СКР_09', 'Group_КВР_СКР_10',
          'Group_КВР_СКР_11', 'Group_КВР_СКР_12', 'Group_КВР_СКР_13', 'Group_КВР_СКР_14', 'Group_КВР_СКР_15',
          'Group_DELTA1_2', 'Group_DELTA2_3', 'Group_DELTA3_4', 'Group_DELTA4_5', 'Group_DELTA5_6', 'Group_DELTA6_7',
          'Group_DELTA7_8', 'Group_DELTA8_9', 'Group_DELTA9_10', 'Group_DELTA10_11', 'Group_DELTA11_12', 'Group_DELTA12_13',
          'Group_DELTA13_14', 'Group_DELTA14_15',
          'КВР_Т_ПЛАН',  # 2
          'КВР_Т_1_ПР',  # 7
          'S2_START',  # 3
          'КВР_Т_ПОСЛ',
          'КВР_ПРОХ',  # 1
          'ПЕЧЬ_ДУО',  # 4
          'ДУО_ВРЕМЯ',  # 4
          'ДУО_КВР',  # 4
          'КВР_ВРЕМЯ',  # 8
          'УГЛ_ЭКВ',  # 5
          'КХС',  # 2
          'C',  # 2
          'SI',  # 6
          'MN',  # 7
          'P',  # 9
          'S',  # 3
          'CR',  # 5
          'NI',  # 8
          'CU',
          'TI',
          'AL',  # 8
          'N2',
          'NB',
          'V',  # 0
          'B',  # 0
          'MO',  # 1
          'ISP_OB',
          'T_KCU',
          'T_KCV',
          'T_KCD',
          'T_KCDV'
]

group_starts_with = {
        'Group_ДУО_ОБЖ_01': ['ДУО_ОБЖ_01','ДУО_ОБЖ_02','ДУО_ОБЖ_03','ДУО_ОБЖ_04','ДУО_ОБЖ_05','ДУО_ОБЖ_06','ДУО_ОБЖ_07','ДУО_ОБЖ_08','ДУО_ОБЖ_09','ДУО_ОБЖ_10','ДУО_ОБЖ_11','ДУО_ОБЖ_12','ДУО_ОБЖ_13','ДУО_ОБЖ_14','ДУО_ОБЖ_15',],  # 8
        'Group_ДУО_УСС_01': ['ДУО_УСС_01','ДУО_УСС_02','ДУО_УСС_03','ДУО_УСС_04','ДУО_УСС_05','ДУО_УСС_06','ДУО_УСС_07','ДУО_УСС_08','ДУО_УСС_09','ДУО_УСС_10','ДУО_УСС_11','ДУО_УСС_12','ДУО_УСС_13','ДУО_УСС_14','ДУО_УСС_15',],  # 7
        'Group_ДУО_УСП_01': ['ДУО_УСП_01','ДУО_УСП_02','ДУО_УСП_03','ДУО_УСП_04','ДУО_УСП_05','ДУО_УСП_06','ДУО_УСП_07','ДУО_УСП_08','ДУО_УСП_09','ДУО_УСП_10','ДУО_УСП_11','ДУО_УСП_12','ДУО_УСП_13','ДУО_УСП_14','ДУО_УСП_15',],  # 3
        'Group_ДУО_СКР_01': ['ДУО_СКР_01','ДУО_СКР_02','ДУО_СКР_03','ДУО_СКР_04','ДУО_СКР_05','ДУО_СКР_06','ДУО_СКР_07','ДУО_СКР_08','ДУО_СКР_09','ДУО_СКР_10','ДУО_СКР_11','ДУО_СКР_12','ДУО_СКР_13','ДУО_СКР_14','ДУО_СКР_15'],
        'Group_КВР_ОБЖ_01': ['КВР_ОБЖ_01','КВР_ОБЖ_02','КВР_ОБЖ_03','КВР_ОБЖ_04','КВР_ОБЖ_05','КВР_ОБЖ_06','КВР_ОБЖ_07','КВР_ОБЖ_08','КВР_ОБЖ_09','КВР_ОБЖ_10','КВР_ОБЖ_11','КВР_ОБЖ_12','КВР_ОБЖ_13','КВР_ОБЖ_14','КВР_ОБЖ_15',],  # 9
        'Group_КВР_УСС_01': ['КВР_УСС_01','КВР_УСС_02','КВР_УСС_03','КВР_УСС_04','КВР_УСС_05','КВР_УСС_06','КВР_УСС_07','КВР_УСС_08','КВР_УСС_09','КВР_УСС_10','КВР_УСС_11','КВР_УСС_12','КВР_УСС_13','КВР_УСС_14','КВР_УСС_15',],
        'Group_КВР_УСП_01': ['КВР_УСП_01','КВР_УСП_02','КВР_УСП_03','КВР_УСП_04','КВР_УСП_05','КВР_УСП_06','КВР_УСП_07','КВР_УСП_08','КВР_УСП_09','КВР_УСП_10','КВР_УСП_11','КВР_УСП_12','КВР_УСП_13','КВР_УСП_14','КВР_УСП_15',],  # 8
        'Group_КВР_СКР_01': ['КВР_СКР_01','КВР_СКР_02','КВР_СКР_03','КВР_СКР_04','КВР_СКР_05','КВР_СКР_06','КВР_СКР_07','КВР_СКР_08','КВР_СКР_09','КВР_СКР_10','КВР_СКР_11','КВР_СКР_12','КВР_СКР_13','КВР_СКР_14','КВР_СКР_15'],  # 9
        'Group_DELTA1_2': ['DELTA1_2','DELTA2_3','DELTA3_4','DELTA4_5','DELTA5_6','DELTA6_7','DELTA7_8','DELTA8_9','DELTA9_10','DELTA10_11','DELTA11_12','DELTA12_13','DELTA13_14','DELTA14_15'],  # 5
}